#include <mega16.h> 
#include <delay.h>

//      
#define         strobe          PORTA.2                          
#define         data            PORTA.1
#define         clock           PORTA.0

unsigned char byte1, byte2, byte3, byte4, byte5;        //5  - 5   

// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)          //  
        {
        unsigned char i, temp;
        
        TCNT0=0x94;
        
        byte1 = ~byte1;                                 //   
        byte2 = ~byte2;
        byte3 = ~byte3;
        byte4 = ~byte4;
        byte5 = ~byte5;
                
        temp = byte1;                                   //      
        for (i = 0; i < 8; i++)
                {
                if ((temp & 1)) data = 1;
                        else data = 0;
                clock = 1;
                clock = 0;
                temp = temp/2;
                };
        
        temp = byte2;
        for (i = 0; i < 8; i++)
                {
                if ((temp & 1)) data = 1;
                        else data = 0;
                clock = 1;
                clock = 0;
                temp = temp/2;
                };
        
        temp = byte3;
        for (i = 0; i < 8; i++)
                {
                if ((temp & 1)) data = 1;
                        else data = 0;
                clock = 1;
                clock = 0;
                temp = temp/2;
                };
        
        temp = byte4;
        for (i = 0; i < 8; i++)
                {
                if ((temp & 1)) data = 1;
                        else data = 0;
                clock = 1;
                clock = 0;
                temp = temp/2;
                };
        
        temp = byte5;
        for (i = 0; i < 8; i++)
                {
                if ((temp & 1)) data = 1;
                        else data = 0;
                clock = 1;
                clock = 0;
                temp = temp/2;
                };
                
        strobe = 1;
        strobe = 0;
        }

unsigned char sign (unsigned char digit, unsigned char point)           //      ..
        {
        unsigned char res;
        
        switch (digit)                                                  //    
                {                                                       //      
                case 0:  res=0b01110111;	break; 
                case 1:  res=0b01000001;	break; 
                case 2:  res=0b00111011;	break; 
                case 3:  res=0b01101011;	break; 
                case 4:  res=0b01001101;	break; 
                case 5:  res=0b01101110;	break; 
                case 6:  res=0b01111110;	break; 
                case 7:  res=0b01000011;	break; 
                case 8:  res=0b01111111;	break; 
                case 9:  res=0b01101111;	break; 
                case 10: res=0b01011111;	break; 
                case 11: res=0b01111100;	break; 
                case 12: res=0b00110110;	break; 
                case 13: res=0b01111001;	break; 
                case 14: res=0b00111110;	break; 
                case 15: res=0b00011110;	break;
                default: res=0;                                         //,    -  
                }
        if (point) res |= 0b10000000;                                   //    -   
        
        return res;
        }

void print (char col0, char col1, char col2, char one, char minus, char arrow, char dig2, char dig3, char dig4, char dig5, char dot1, char dot2, char dot3, char dot4)
        {               //                                                                      
        #asm ("cli")    // 
        TCCR0=0x00;     // 
        
        byte1 = 0;                              //1 - ,    
        
        if (dot1)   byte1 |= 0b10000000;        //  
        if (col1)   byte1 |= 0b00100000;        //     
        if (col2)   byte1 |= 0b01000000;        //     
        if (one)    byte1 |= 0b00010000;        //  
        if (minus)  byte1 |= 0b00001000;        //  
        if (arrow)  byte1 |= 0b00000001;        // 
        if (col0)   byte1 |= 0b00000010;        //   (" " :) )
        
        byte2 = sign (dig2, dot2);              //     4 
        byte3 = sign (dig3, dot3);
        byte4 = sign (dig4, dot4);
        byte5 = sign (dig5, 0);                 //    ,   0
        
        TCCR0=0x05;                             //   
        TCNT0=0x94;
        #asm ("sei")                            // 
        }

void main(void)
{

// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=Out Func1=Out Func0=Out 
// State7=T State6=T State5=T State4=T State3=T State2=0 State1=0 State0=0 
PORTA=0x00;
DDRA=0x07;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Normal top=FFh
// OC0 output: Disconnected
TCCR0=0x05;
TCNT0=0x94;
OCR0=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x01;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

#asm ("sei")

while (1)
        {
        
    
	for (j = 0; j<15; j++)          //       
                {
                print (0, 0, 0, 0, 0, 0, j, j+1, j+2, j+3, 0, 0, 0, 0);
                delay_ms(1000);
                print (0, 0, 0, 0, 0, 0, j, j+1, j+2, j+3, 0, 0, 0, 1);
                delay_ms(1000);
                print (0, 0, 0, 0, 0, 0, j, j+1, j+2, j+3, 0, 0, 1, 0);
                delay_ms(1000);
                print (0, 0, 0, 0, 0, 0, j, j+1, j+2, j+3, 0, 1, 0, 0);
                delay_ms(1000);
                print (0, 0, 0, 0, 0, 0, j, j+1, j+2, j+3, 1, 0, 0, 0);
                delay_ms(1000);
                print (0, 0, 0, 0, 0, 1, j, j+1, j+2, j+3, 0, 0, 0, 0);
                delay_ms(1000);
                print (0, 0, 0, 0, 1, 0, j, j+1, j+2, j+3, 0, 0, 0, 0);
                delay_ms(1000);
                print (0, 0, 0, 1, 0, 0, j, j+1, j+2, j+3, 0, 0, 0, 0);
                delay_ms(1000);
                print (0, 0, 1, 0, 0, 0, j, j+1, j+2, j+3, 0, 0, 0, 0);
                delay_ms(1000);
                print (0, 1, 0, 0, 0, 0, j, j+1, j+2, j+3, 0, 0, 0, 0);
                delay_ms(1000);
                print (1, 0, 0, 0, 0, 0, j, j+1, j+2, j+3, 0, 0, 0, 0);
                delay_ms(1000);
                }
        }
}
